open Syntax

val raiseunknownname : bool ref

val maxelaborateiters : int ref
val elaboratelim : int ref
val elaboratetimeout : float ref
val acceptcommonmizartypes : bool ref

val main_queried_sorts : (trm,unit) Hashtbl.t
val main_assumed_sorts : (trm,unit) Hashtbl.t
val assume_needed_sorts : int ref

val count_assumed : (string * Syntax.trm list) list -> int
val count_queried : (string * Syntax.trm list) list -> int

exception UnknownName of string

val collecttypingaxioms : bool ref
type mizartypingaxiom =
  | MizarTypeHierarchyStrict of string * string list * int * trm list * trm list
  | MizarTypeHierarchy of string * string list * int * trm list * trm list
  | MizarFunctionType of string * string list * int * trm list * trm list
  | MizarTypingGeneric of string * int * trm list * trm list
  | MizarRedefinition of string * int * trm list * string * trm list * trm
val typingaxiomslist : mizartypingaxiom list ref

val mizar_pattern_table : (string,int * trm list * stp * int list * trm * trm) Hashtbl.t
val mizar_pattern_list : (string * int * trm list * stp * int list * trm * trm) list ref

val mizar_name_tp : (string,stp) Hashtbl.t ref
val mizar_symbol_order_pred : (string, string) Hashtbl.t ref

val extract_conjuncts : trm -> bool -> trm list

val names_in_mizar_type_assumptions : string list ref
val mizar_hook_names : string list ref

val mizar_func_types : (string,string * int * trm list * trm list) Hashtbl.t
val mizar_typing : (string,string * int * trm * trm list * trm list) Hashtbl.t
val mizar_typing_gen_forward : (string,string * int * trm * trm list * trm list) Hashtbl.t
val mizar_typing_gen_backward : (string,string * int * trm * trm list * trm) Hashtbl.t
val mizar_redef : (string,string * int * trm list * trm list * trm) Hashtbl.t

val mizar_type_fact1_p : trm -> int -> trm list -> int * trm list * trm list
val mizar_type_fact2o_p : trm -> bool
val mizar_type_fact3o_p : trm -> bool
val mizar_type_fact4o_p : trm -> bool
val mizar_type_fact5o_p : trm -> int -> trm list -> int * trm list * string * trm list * trm

val mizar_pattern : trm -> int -> trm list -> string * int * trm list * stp * int list * trm * trm

val pre_head_spine : pretrm -> pretrm list -> pretrm * pretrm list
    
exception ElaborationSimpleTypeError of trm * stp * stp
exception ElaborationPatternArityError of string * int * int
exception ElaborationFailure of string

type cctables = (trm,unit) Hashtbl.t * (trm,trm) Hashtbl.t * (trm,trm) Hashtbl.t * (trm,trm) Hashtbl.t

val abstract_subterms : int -> trm -> trm -> trm

type mizstate = (pretrm,trm * stp * ((string * (trm list)) list)) Hashtbl.t * (trm,trm) Hashtbl.t * (trm,trm) Hashtbl.t * (trm,unit) Hashtbl.t * cctables * ((string,unit) Hashtbl.t * bool ref * int ref)
      
val nxtfreshvar : stp -> mizstate -> trm

val union_frees : ((string * (trm list)) list) -> ((string * (trm list)) list) -> ((string * (trm list)) list)
    
val mizar_widen : mizstate -> trm list -> int -> unit
val mizar_elaborate_trm : mizstate -> (string * trm) list -> pretrm -> trm * stp * ((string * (trm list)) list)
val mizar_elaborate_trm_force_stp : mizstate -> (string * trm) list -> pretrm -> stp -> trm * ((string * (trm list)) list)

